using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RFramework;

namespace RFrameGenerate.Model
{
    public partial class T_ST_ActivityCoupons: EntityBase<T_ST_ActivityCoupons>, ICloneable
    { 
        public Guid StoreActivityGuid{ get;set; }   
        public Guid StoreCouponsGuid{ get;set; }   
        public DateTime? StartDate{ get;set; }   
        public DateTime? EndDate{ get;set; }   
        public int? State{ get;set; }   
        public string ActivityName{ get;set; }
        public Guid? MerchantGuid{ get;set; }   
        public decimal? Amount{ get;set; }   
        public int? EachNum{ get;set; }   
        public int? ReceivedNum{ get;set; }   
        public int? TotalNum{ get;set; }   
        public int? ServiceConditions{ get;set; }   
        public decimal? ServiceConditionsMoney{ get;set; }   
        public int? ValidityType{ get;set; }   
        public int? ValidityDays{ get;set; }   
        public DateTime? ValidityStartDate{ get;set; }   
        public DateTime? ValidityEndDate{ get;set; }   
        public Guid? SMerchantGuid{ get;set; }   
        public bool? IsLimit{ get;set; }   
      
        public override string ToString()
        {
            StringBuilder sb = this.EntityToGetKeyValue();
            if (sb == null)
                return base.ToString();
            else
            {
                return sb.ToString();
            }
        }
        
        #region 创建副本
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public object Clone()
        {
            return this.MemberwiseClone();
        }
        
        /// <summary>
        /// 创建当前 System.Object 的深表副本
        /// </summary>
        /// <returns>返回当前实例的深表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_ST_ActivityCoupons DeepClone()
        {
            using (System.IO.Stream objectStream = new System.IO.MemoryStream())
            {
                System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Serialize(objectStream, this);
                objectStream.Seek(0, System.IO.SeekOrigin.Begin);
                return formatter.Deserialize(objectStream) as T_ST_ActivityCoupons;
            }
        }
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_ST_ActivityCoupons ShallowClone()
        {
            return Clone() as T_ST_ActivityCoupons;
        }

        #endregion
        
        #region 实体相互转换        
        protected override T_ST_ActivityCoupons CurrentEntity()
        {
            return this;
        }
        #endregion
    }
}

